
shader = require 'fourD'

function love.load()
	wd, ht = 400, 400
	love.graphics.setMode( wd, ht, {} )
	gt = 0
	love.graphics.setCaption( 'Four D?' )
	screen = { ht, wd }
	love.graphics.setBackgroundColor( 255, 255, 255 )
	shader.effect:send( 'screen', screen )
	end

function love.update( dt )
	gt = gt + dt
	shader.effect:send( 'time', gt )
	end

function love.draw()
	love.graphics.setColor( 255, 255, 255 )
	love.graphics.setPixelEffect( shader.effect )
	love.graphics.rectangle( "fill", 0, 0, wd, ht )
	love.graphics.setPixelEffect()
	love.graphics.setColor( 255, 255, 255, 255 )
	love.graphics.print( 'fps: '..love.timer.getFPS(),10, 10 )
	end

function love.keypressed( key )
	if key == 'escape'	then love.event.push( 'quit' )	end
	end
